#ifndef RCL_DATABUFFER_HPP
#define RCL_DATABUFFER_HPP

#include <fstream>

class DataBuffer {
public:
    DataBuffer(int size);
    DataBuffer(const DataBuffer& buffer);
    virtual ~DataBuffer();

    DataBuffer& operator=(const DataBuffer& rhs);
    char& operator[](int i) {return *(this->Data+i);}
    const char& operator[](int i) const {return *(this->Data+i);}
    void readFile(std::ifstream& file, int size);
    void writeFile(std::ofstream& file, int size);
    int size(){return this->Size;}
private:
    DataBuffer(){} // disable default constructor.
    char* Data;
    int Size;
};

#endif
