#include <iostream>
#include "cl_args_e.hpp"

arg::ArgsError::~ArgsError(){;}

void arg::ArgsError::debug() const
{
    std::cerr << "ERROR: Invalid command line arguments\n"
	      << "\nDF3 file not created. Use -h for help.\n";
}

void arg::Input::debug() const
{
    std::cerr << "ERROR:\t Invalid command line arguments\n"
	      << "ERROR:\t recieved both -b and -f\n"
	      << "\nDF3 file not created. Use -h for help.\n";
}

void arg::FromBasename::debug() const
{
    std::cerr << "Reading files by basename is not implemented.\n"
	      << "for unix-like systems (Linux, Solaris, etc..) try:\n"
	      << "\tls -1 your_tga*.tga | tga2df3\n\n"
	      << "for DOS based systems try:\n"
	      << "\tdir /B /ON your_tga*.tga | tga2df3.exe\n"
	      << "\nDF3 file not created. Use -h for help.\n";
}

void arg::FromList::debug() const
{
    std::cerr << "ERROR: -f requires a file name\n"
	      << "\nDF3 file not created. Use -h for help.\n";
}

void arg::SetOutput::debug() const
{
    std::cerr << "ERROR: -o requires a file name\n"
	      << "\nDF3 file not created. Use -h for help.\n";
}
