#ifndef RCL_DF3_HPP
#define RCL_DF3_HPP

#include "df3_e.hpp"
#include "tga_e.hpp"

/* forward declarations to avoid unnecesary #includes */
namespace tga { class TGA; }
namespace arg { class CL_Args; }
class DataBuffer;
/* end of forward declarations */

namespace df3 {

    class DF3 {
    public:
	DF3(std::string filename)
	    : file(filename.c_str(), std::ios_base::binary),
	      name(filename)
	{ 
	    this->width = -1;
	    this->height = -1;
	    this->depth = 0;
	    this->tgatype = -1;
	    this->pixels = 0;
	    this->header = -1;
	}
	~DF3()  
	{ 
	    this->file.close();  
	} 
	
	void tga2df3(std::string file, arg::CL_Args *args) throw();
	    //	    throw (df3::MismatchError, df3::OutputError, tga::TypeError);
	
	void setDepth(int d) {this->depth = d;}
	int getDepth() {return this->depth;}
	int writeDF3Header(tga::TGA* tga);
	std::string getName() {return this->name;}        
	void debug() const;
    private: 
	bool inconsistant(tga::TGA* tga);
	bool DF3isNew();
	void writeInt(int value);
	void voxelize(DataBuffer& DF3_frame, DataBuffer& image_data, tga::TGA& tgafile);
	    
	std::ofstream file; 
	std::string name;
	int width;
	int height;
	int depth;
	int tgatype;
	int pixels;    
	int header;
    };
}

#endif
