#ifndef RCL_DF3_E_HPP
#define RCL_DF3_E_HPP

#include <string>
#include "DF3Exceptions.hpp"

namespace df3 {

    class DF3Error : public Exceptions::DF3Exceptions {
    public:
	DF3Error() {}
	virtual ~DF3Error();
	virtual void debug() const;
    };
    
    class OutputError : public DF3Error{
    public:
	OutputError(std::string name)
	    :filename(name) {}
	virtual void debug() const;
    private:
	std::string filename;
    };
    
    class MismatchError : public DF3Error{
    public:
	MismatchError(std::string filename, int df3_w, int df3_h, int df3_t,
		      int tga_w, int tga_h, int tga_t);
	virtual void debug() const;
    private:
	std::string filename;
	int df3_w, df3_h, df3_t, tga_w, tga_h, tga_t;
    };

}

#endif
